






<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">


<html>
<head>
<meta http-equiv="PRAGMA" content="NO-CACHE">
<meta http-equiv="EXPIRES" content="0">

<title>SecurityPortal - Postfix - The Sendmail replacement part II</title>


<meta name="Description" content="Postfix was reviewed over one year ago and since then it has gotten even better. Postfix is now more useful than ever for use as a gateway mail server, This article will cover some of the new features and how to use them to secure and protect your email infrastructure. ">


<link rel=stylesheet href="sp.css">
<script language="JavaScript">
<!--
if(navigator.userAgent.indexOf('Linux') != -1) {
document.write("<LINK rel=stylesheet HREF=/sp.nonwin.css>");
}
//-->
</script>

</head>

<body leftmargin=0 topmargin=0 marginheight=0 marginwidth=0 link="#cc0000" vlink="#990000">

<form method=GET action=http://search.securityportal.com/query.html>


<table width=100% cellpadding=0 cellspacing=0 border=0>
<tr>
<td>
<table width=100% cellpadding=0 cellspacing=0 border=0>

<tr>
<td height=10><img src=t.gif alt="" width=10 height=10 border=0></td>
</tr>

<tr>
<td height=62 width=10 rowspan=3><img src=t.gif alt="" width=10 height=62 border=0></td>
        <td height=62 width=306 rowspan=3><img src=securityportal.gif width=306 height=62 alt="SecurityPortal" border=0 usemap="#Map"></td>
        <td class=paddate width=80% height=18 bgcolor=#000000 text=#FFFFFF valign=bottom><img src=t.gif alt="" width=15 height=1 border=0 align=left><font class=date>Jun 03, 2001</font></td><td width=120 height=18>

	      <table width=170 cellpadding=0 cellspacing=0 height=18 border=0>
            <tr> 
              <td align=center valign=middle><a href="/about/" class=lbg>About 
                Us</a></td>
              <td align=center valign=middle><a href="/about/sponsorship.html" class=lbg>Advertise</a></td>
              <td align=center valign=middle><a href="/feedback.html" class=lbg>Feedback</a></td>
            </tr>
          </table>

</td><td width=2 height=18><img src=t.gif alt="" width=2 height=18 border=0></td>
</tr>

<tr>
<td colspan=3 bgcolor=#000000 text=#FFFFFF height=3><img src=t.gif alt="" width=3 height=3 border=0></td>
</tr>

<tr>
<td colspan=3 bgcolor=#000099 text=#ffff33 height=41 align=left>

	<table width=328 height=41 cellpadding=0 cellspacing=0 border=0>
	<tr>
	<td width=19><img src=c.gif alt="" width=19 height=41 border=0></td>
<td valign=center class=search align=right>
<input type=text name=qt size=9 value="" maxlength=2033 class=search>
<input type=hidden name=col value=topnews>
<input type=hidden name=col value=other>
<input type=hidden name=col value=lists>
<input type=hidden name=col value=lskb>
</td><td valign=middle><input type=image name=search src=search.gif alt=Search
border=0><br><a href="http://search.securityportal.com"><img src=options.gif width=66 height=11 alt=options border=0></a></td>

<td width=35><img src=t.gif alt="" width=35 height=41 border=0></td>

<td valign=middle class=search><font class=white><a href="http://listserv.securityportal.com/SCRIPTS/WA-SECURITYPORTAL.EXE?SUBED1=securityportal-l&A=1" class=yel><b>SUBSCRIBE</b></a> to our<br>
                Weekly Newsletters</font></td>

	</tr>
	</table>

</td>
</tr>

</table>
</td></tr>
<!-- ********** Left Menu Starts Here ********** -->
<tr><td>

<table width=100% cellpadding=0 cellspacing=0 border=0>

<tr>
<td width=10 rowspan=6><img src=t.gif alt="" width=10 height=10 border=0></td><td width=8 rowspan=6 bgcolor=#000000 text=#FFFFFF><img src=t.gif alt="" width=8 height=8 border=0></td><td width=108 rowspan=6 valign=top bgcolor=#000000 text=#FFFFFF align=center>

<img src=n.gif alt="" width=108 height=21 border=0><br>

	<table  width=108 cellpadding=0 cellspacing=0 border=0>
	<tr>
	<td  valign=top>
	<div class="navtit">Hot Topics!<br></div>
<table width=105 cellpadding=0 cellspacing=0 border=0>

<!-- ********** Hot Topics ********** -->
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/php/t.php?l=41&s=7" class=yel>IIS</a></td>
              </tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/php/t.php?l=37&s=7"
class=yel>Sulfnbk.exe</a></td>
              </tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="http://securityportal.com/php/t.php?l=40&s=7" class=yel>Personal 
                  Firewalls </a></td>
              </tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/php/t.php?l=34&s=7"
class=yel>Lopez Worm</a></td>
              </tr>
<!-- ********** End Of Hot Topics ********** -->

</table>

<div class=navtit>Services<br></div>
   <table width=105 cellpadding=0 cellspacing=0 border=0>
<!--<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td><td class=nav><a href="/services/" class=yel>All Services</a></td></tr>-->
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/php/t.php?l=17&s=7" class=yel>NetRadarEWS</a></td>
              </tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/php/t.php?l=9&s=7" class=yel>InfoSecU</a></td>
              </tr>
<!--<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td><td class=nav><a href="/services/securityquestesb/" class=yel>SecurityQuest</a></td></tr>-->
</table>

<div class=navtit>Top News<br></div>
   <table width=105 cellpadding=0 cellspacing=0 border=0>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/" class=yel>All News</a></td>
              </tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td><td class=nav><a href="/topnews/linuxnews.html" class=yel>Linux</a></td></tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td><td class=nav><a href="/topnews/microsoftnews.html" class=yel>Microsoft</a></td></tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td><td class=nav><a href="/topnews/virusnews.html" class=yel>Virus</a></td></tr>
<tr><td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td><td class=nav><a href="/pr/" class=yel>Press Releases</a></td></tr>
</table>

<div class=navtit>Features<br></div>
            <table width=105 cellpadding=0 cellspacing=0 border=0>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/buffy/" class=yel>Ask Buffy</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/kfiles/" class=yel>K-Files</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/closet/" class=yel>Kurt's Closet</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/research/virus/virustop20.html" class=yel>Top 
                  20 Virus</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/research/research.featurearchives.html" class=yel> 
                  Archives</a></td>
              </tr>
            </table>
<div class=navtit>Centers<br></div>
              
            <table width=105 cellpadding=0 cellspacing=0 border=0>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/firewalls/" class=yel>Firewalls</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/virus/" class=yel>Virus/Malware</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/research/research.sec101.html" class=yel>Security 
                  101 </a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/careers" class=yel>Careers</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/community/" class=yel>Community</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/eforensics/" class=yel>eForensics</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/networking/" class=yel>Networking</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/cryptography/" class=yel>Crypto/PKI</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/research/research.products.html" class=yel>Vendors</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/microsoft/" class=yel>Microsoft</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/macintosh/" class=yel>Macintosh</a></td>
              </tr>
              <tr> 
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/research/" class=yel>More...</a></td>
              </tr>
            </table>
<div class=navtit>Weekly Digests<br></div>
            <table width=105 cellpadding=0 cellspacing=0 border=0>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/bsd.html" class=yel>BSD</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/careers.html" class=yel>Careers</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/checkpoint.html" class=yel>Check 
                  Point</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/exec.html" class=yel>Executive</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/linux.html" class=yel>Linux</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/microsoft.html" class=yel>Microsoft</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/pgp.html" class=yel>PGP</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/raptor.html" class=yel>Raptor</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/solaris.html" class=yel>Solaris</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/tools.html" class=yel>Tools</a></td>
              </tr>
              <tr>
                <td width=8 valign=top><img src=navlist.gif width=3 height=9 alt="."></td>
                <td class=nav><a href="/topnews/weekly/virus.html" class=yel>Virus</a></td>
              </tr>
            </table>
            <div class=navtit></div>
            <hr size=1 noshade>
            <div class=navtit2> <a href="http://cryptoarchive.net/" class=yel>CryptoArchive</a><br>
<a href="/forum/" class=yel>Discussion Forum</a><br>
</div>
<hr size=1 noshade>

	</td>
	</tr>
	</table>
	
      <div class=search> <a href="/palm/" class=lbg>Get SecurityPortal To Go</a></div>

<!-- ********** End of Left Menu ********** -->	
	
</td><td width=8 rowspan=5 bgcolor=#000000 text=#FFFFFF valign=top><img src=n2.gif width=8 height=70 alt="" border=0></td><td width=2 bgcolor=#ffcc00 rowspan=5><img src=t.gif alt="" width=2 height=10 border=0></td><td width=100% bgcolor=#ffcc00 height=2><img src=t.gif alt="" width=2 height=2 border=0></td><td width=2 bgcolor=#000000 text=#FFFFFF rowspan=5><img src=t.gif alt="" width=2 height=2 border=0></td>
</tr>


<tr height=60>
<!-- Advertisement -->
<td height=60 bgcolor=#666666><!-- Ad Location=topnews(default)-->
<a href="/cgi-bin/state/gotoad.cgi?031401094922"><img border=0 bordercolor=#000000 src="468x60_securityBanner.gif" alt="" class=banner></a></tr>
</tr>

<tr>
<td bgcolor=#000000 text=#FFFFFF height=2><img src=t.gif alt="" width=2 height=2 border=0></td>
</tr>


<tr>
<td bgcolor=#ffffff text=#000000 valign=top>

	<table cellpadding=0 cellspacing=0 border=0>
	
	<tr>
	<td width=8><img src=t.gif alt="" width=8 height=10 border=0></td>
	<td width=85% valign=top>
	<br>
	</form>

<!-- ******************** -->
<map name="Map"> 
        <area shape="rect" coords="85,42,265,62" href="/php/t.php?l=1" alt="AtomicTangerine" title="AtomicTangerine">
  <area shape="rect" coords="-4,1,304,61" href="/" alt="SecurityPortal" title="SecurityPortal">
</map>


<h1>Postfix - The Sendmail Replacement, Part II</h1>

<p><i>By Kurt Seifried (<a href="mailto:seifried@securityportal.com">seifried@securityportal.com</a>) for <a href="http://securityportal.com/">SecurityPortal</a></i></p>

<p><a href="http://www.securityportal.com/research/research.closetarchives.html">Kurt's Closet Archive</a></p>

<br><hr>


<table align=right border=0 vspace=10 hspace=5 cellpadding="0" cellspacing="0" bordercolor="#000099" width="250">
  <tr>
    <td><img src="t.gif" width="1" height="20"></td>
  </tr>
  <form method="POST" action="/cgi-bin/subscribe.pl">
    <tr> 
      <td> 
        <table width="100%" border="1" cellspacing="0" cellpadding="5" bordercolor="#000099">
          <tr>
            <td><b>Subscribe</b> to get <b>FREE</b> security news, commentary, 
              and articles.<br>
              <br>
              <input type="text" name="email" size=15 value="(email address)">
              <!--Name: <input type="text" name="from" size=15 ><br>-->
              <input type="hidden" name="from">
              <input type=submit value="Go" name="submit">
            </td>
          </tr>
        </table>
        
      </td>
    </tr>
  </form>
</table>



<p><b>November 22, 2000 - </b>I've written about Postfix before, over a year 
  ago, and since then it has gotten even better. I must confess that I've been using 
  the 31 Dec. 1999 release on my servers until last week, which, while extremely stable, 
  lacks a lot of the features now available in current snapshots of Postfix. Postfix 
  is now more useful than ever as a gateway mail server. I'll cover some 
  of the more interesting available features and how you can use them to secure 
  and protect your email infrastructure. Most of these features are actually quite 
  old, but are probably news to most users.</p>
<p>This article was written using Postfix snapshot 20001030. Since then several
things (like virtual) have changed, making some points in this article
incorrect.</p>
<h3><b><br>
  Check_recipient_access</b></h3>
<p>This is probably the best way of restricting incoming email to valid email 
  accounts only. Let's assume you have a decent-sized corporate LAN based on Windows 
  and are using Exchange server for email. Exchange can only validate incoming 
  email based on the domain, not the user, and since it will attempt to deliver 
  the email for 48 hours, your system can get quickly clogged up - with
  no easy way to clean it out. Place your Exchange server behind a firewall so 
  no one on the Internet can connect to it directly, and then place a Postfix server 
  on the public side. Add this to your main.cf:</p>
<blockquote> 
  <pre>smtpd_sender_restrictions = check_recipient_access<br> hash:/etc/postfix/access-inbound</pre>
</blockquote>
<p>Then in your /etc/postfix/access-inbound file, simply put,</p>
<blockquote> 
  <pre>validuser@example.org	OK
example.org		REJECT</pre>
</blockquote>
<p>You will also need to create the hash file. The following command will do so:</p>
<blockquote> 
  <pre>postmap /etc/postfix/access</pre>
</blockquote>
<p>You could also use the generic access file, but splitting it up allows for extremely 
  selective access controls. You can then have the mail delivered locally or forwarded 
  to another (internal) system. If an email is sent to an email address not listed 
  specifically, and the domain is covered by a reject rule, the sender will receive 
  an email with an error like,</p>
<blockquote> 
  <pre>The Postfix program
&lt;useraccount@stench.seifried.org&gt;: <br>host stench.seifried.org[10.3.0.10] said: 554
&lt;useraccount@stench.seifried.org&gt;: <br>Recipient address rejected: Access denied</pre>
</blockquote>
<p>You can also specify a custom error such as &quot;useraccount does not exist.&quot; 
  However, a spammer could theoretically use this to build an address list by simply 
  testing all the email addresses - those that generate an error message do not 
  exist, and those that do not generate one do exist.</p>
<h3><br>
  Virtual</h3>
<p>This feature can be used as intended, for having virtual users (i.e., 
  if you handle multiple domains and more than one wants a webmaster@ email address) 
  as well as for protecting internal servers. </p>
<blockquote> 
  <pre>virtual_maps = hash:/etc/postfix/virtual</pre>
</blockquote>
<p>Then in your /etc/postfix/virtual simply remap email:</p>
<blockquote> 
  <pre>userbob@example.org	userbob@internal-mail.example.org
userbo@example.org	userbo@internal-mail.example.org
userbill@example.org	userbill@internal-mail.example.org
@example.org		bounce-local</pre>
</blockquote>
<p>You will also need to create the hash file:</p>
<blockquote> 
  <pre>postmap /etc/postfix/virtual</pre>
</blockquote>
<p>If incoming email does not match a virtual user, mapping it is sent to another 
  address, in this example a local user called &quot;bounce-local.&quot; It may 
  then be blackholed to /dev/null, simply bounced (no such user), or sent to an 
  admin email account - where it is deleted or forwarded to the correct person, 
  if an obvious typo was made in the address, or whatever. You can also use a database 
  backend instead of a hash or dbm file. This is definitely the way to go for 
  large installations. See man virtual(5) for more information. Simply use the 
  same machine as the outbound mail server (i.e., smart host) and it will rewrite 
  the email addresses outgoing from @internal-mail.example.org to @example.org 
  (or whatever you want).</p>
<h3><br>
  Local_recipient_maps</h3>
<p>This keyword lets you allow only local delivery of email to valid users 
  and/or definitions in the aliases map. Thus any email bound for a nonexistent 
  user gets bounced immediately with an error message saying the user does not 
  exist. This is useful if you the postmaster do not want to receive as many error 
  messages. Potentially, however, an attacker could use this to find valid names 
  (anything valid won't generate an error). This is probably most useful for large 
  installations such as ISPs and large corporations. An additional consideration 
  would be to use relocated_maps. Simply put this in your main.cf:</p>
<blockquote> 
  <pre>local_recipient_maps = $alias_maps unix:passwd.byname</pre>
</blockquote>
<p>This will accept any email defined in aliases or for user accounts in the password 
  database.</p>
<h3><br>
  Relocated_maps</h3>
<p>This is an ideal feature for large companies that want to remap users without 
  too much trouble. It allows you to specify the original email address and 
  the new email address. For example, user joebob goes to another ISP instead of 
  forwarding all their mail, which results in senders not realizing it has changed. 
  They get an error message specifying the new email address. This can be 
  used for wholesale domain moves as well. Simply add the following to your main.cf:</p>
<blockquote> 
  <pre>relocated_maps = hash:/etc/postfix/relocated</pre>
</blockquote>
<p>Then put the email address, username or domain name, followed by 
  the email address or domain name, and anyone sending email in will get a nice error 
  telling them the new address. See man relocated(5) for more information.</p>
<h3><br>
  Blocking Spam</h3>
<p>This is probably one of the favorite features for administrators; under Postfix 
  it is trivial to implement. Simple add the following to your main.cf:</p>
<blockquote> 
  <pre>maps_rbl_domains = rbl.maps.vix.com, dul.maps.vix.com </pre>
</blockquote>
<p>The rbl is the real-time blackhole list, basically a list of known spammers 
  and open relays that spammers use. The dul is the dialup list. Generally speaking, 
  you shouldn't be receiving to much email <i>directly</i> from dialup users, i.e., 
  people using their own servers. However, quite a few legitimate users do set up 
  their own email servers for use on dialup links, and blocking them inadvertently 
  may be a problem. </p>
<h3><br>
  Database Backends</h3>
<p>One thing I really love about Postfix is the ability to use databases instead 
  of flat text files or hash and dbm files. Currently only MySQL is supported, 
  but that is more than sufficient for most users. You must first compile in support 
  for MySQL. See the &quot;MYSQL_README&quot; file for more information on this. 
  Then you simply create a table in the MySQL database of usernames, virtual 
  mappings or whatever. The cool thing is, this allows for very efficient sharing 
  of configuration files between servers; and since you can specify multiple MySQL 
  servers, you can replicate the database and avoid a single point of failure as 
  well as being able to vary the order the databases are listed in on various 
  servers, as a simplistic form of load balancing.</p>
<p>MySQL has plans to add database 
  replication to its available features. For now, you will have to create your 
  own solution, such as a simple tool that connects to and updates all the databases 
  at once. The configuration is reasonably simple. In your main.cf, put something 
  like,</p>
<blockquote> 
  <code>alias_maps = mysql:/etc/postfix/mysql-aliases.cf</code>
</blockquote>
<p>And then in the mysql-aliases.cf, put</p>
<blockquote> 
  <code>user = someone<br>
    password = some_password <br>
    dbname = customer_database<br>
    table = mxaliases<br>
    select_field = forw_addr<br>
    where_field = alias<br>
    additional_conditions = and status = 'paid'<br>
    hosts = maildb1.example.org maildbt2.example.org</code>
</blockquote>
<p>This would allow you to have a table called &quot;mxaliases&quot; in the database 
  called &quot;customer_database,&quot; where the field &quot;forw_addr&quot; matches 
  and where the &quot;status&quot; field is set to &quot;paid&quot; (so you can easily block 
  email to customers who don't fork over). The really useful thing is that you 
  can easily update configuration files on the fly. As soon as it is updated in 
  the database, it's ready to go. Additionally, this makes giving users control 
  over their own accounts much easier. A Web hosting provider could easily let 
  people handle virtual user mappings on their own domain, for example, through 
  a cgi interface.</p>
<h3><br>
  TLS</h3>
<p>Transport Layer Security is to email as SSL is to Web browsing. TLS allows 
  you to encrypt email transfers from server to server, but more importantly, it 
  allows you to add authentication to the mail server. Instead of having to allow 
  access based on IP and hostname, you can use usernames and passwords. That way 
  people can connect securely from off-site - while using dialup on the road -   and spammers are not able to use you as a relay.</p>
<p>There is an add-on TLS package 
  for Postfix (see URL at bottom) available from Germany. (Germany is very pro-encryption; 
  the federal government has even gone so far as to sponsor GnuPG development.) TLS 
  is becoming more common now that the RSA patent has expired. Red Hat 7.0 ships 
  Sendmail configured for TLS out of the box.</p>
<h3><br>
  Regular Expressions</h3>
<p>Postfix supports the use of regular expressions for header rewriting and other 
  neat tricks. There's support for basic regex (regexp), and support for perl-compatible regular expressions (PCRE). The first are simpler. To use them, just
  put this in your main.cf:</p>
<blockquote> 
  <pre>header_checks = regexp:/etc/postfix/header-checks</pre>
</blockquote>
<p>And then add rules to your header-checks file; the target can be REJECT, 
  OK or a custom error.</p>
<blockquote> 
  <pre>/^Subject: Make money fast/		REJECT
/^X-Mailer: Microsoft Outlook Express/	REJECT</pre>
</blockquote>
<p>See man regexp_table(5) for more information. You can also use PCRE by simply 
  specifying pcre: instead of regexp: in your main.cf. The rules are basically 
  the same, except that the syntax used for pattern matching is a bit more advanced.</p>
<blockquote> 
  <pre>/^friend@(?!my.domain).*$/ 550 Stick this in your pipe $0</pre>
</blockquote>
<p>See man pcre_table(5) for more information. </p>
<h2><br>
  Summary</h2>
<p>Postfix is ideal for large installations, with its database backends and extremely 
  tight control of mail delivery. Additionally, it supports numerous security features, 
  such as TLS and even the ability to specify which users are allowed to send 
  mail off-site and which aren't - again, in a very selective manner. Qmail has 
  quite a few of these features, but has one significant problem: The license makes 
  it extremely difficult to distribute in a binary format, which is what most 
  people want.</p>
<p>Postfix, on the other hand, comes under the IBM Public License, which 
  is surprisingly considerate to end users. My real favorite is the simplicity 
  of configuration. An average main.cf is under 30 lines of configuration directives. 
  Hopefully more vendors will start shipping Postfix with their distributions.</p>
<br>
<hr>
<h2><b>Related Links</b></h2>
<p> <b>FAQ and other information pages</b><br>
  <a href="http://www.postfix.org/" target="_blank">http://www.postfix.org/</a></p>
<p><b>TLS for Postfix</b><br>
  <a
href="http://www.aet.tu-cottbus.de/personen/jaenicke/postfix_tls/" target="_blank">http://www.aet.tu-cottbus.de/personen/jaenicke/postfix_tls/</a> 
</p>
<p><b> Postfix RPMs and SRPMs</b><br>
  <a href="http://www.pobox.com/~sjmudd/postfix/" target="_blank">http://www.pobox.com/~sjmudd/postfix/ 
  </a></p>

<!-- ******************** -->

	<br>
	</td><td width=8><img src=t.gif width=8 height=10 alt="" border=0></td><td width=122 valign=top>


<!-- *** Start right cloumn *** -->
	
		<table width=122 cellpadding=0 cellspacing=0 border=0>
		<tr>
		<td width=2 bgcolor=#000000 text=#FFFFFF><img src=t.gif alt="" width=2 height=2 border=0></td><td width=8 bgcolor=#3333cc><img src=t.gif alt="" width=2 height=22 border=0></td><td colspan=2 bgcolor=#3333cc width=112 valign="top" class=headline><img src=t.gif alt="" width=2 height=2 border=0><br><b><a href="/topnews/" class="headline">HEADLINES</a></b></td><td width=8 bgcolor=#3333cc><img src=t.gif alt="" width=2 height=2 border=0></td>
		</tr>		


<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" valign="top" bgcolor="#3333cc"><img src="navlist.gif" alt=""></td>
<td bgcolor="#3333cc" width="104" class="nav"><a href=http://money.iwon.com/jsp/nw/nwdt_rt.jsp?cat=USMARKET&src=201&feed=reu&section=news&news_id=reu-n01435495&date=20010601&alias=/alias/money/cm/nw class=yel>IWON: NetWolves Says GE To Use Its Internet Security System </td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
</tr>
<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
<td colspan="4" bgcolor="#3333cc" width="128"><img src="t.gif" alt="" width="2" height="6" border="0" alt=""></td>


<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" valign="top" bgcolor="#3333cc"><img src="navlist.gif" alt=""></td>
<td bgcolor="#3333cc" width="104" class="nav"><a href=http://www.newsbytes.com/news/01/166384.html class=yel>Newsbytes: SETI At Home Servers Invaded, Users Spammed</td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
</tr>
<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
<td colspan="4" bgcolor="#3333cc" width="128"><img src="t.gif" alt="" width="2" height="6" border="0" alt=""></td>


<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" valign="top" bgcolor="#3333cc"><img src="navlist.gif" alt=""></td>
<td bgcolor="#3333cc" width="104" class="nav"><a href=http://boston.internet.com/briefs/article/0,1928,2371_776661,00.html class=yel>Boston Internet: RSA Security Opens Ireland Plant</td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
</tr>
<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
<td colspan="4" bgcolor="#3333cc" width="128"><img src="t.gif" alt="" width="2" height="6" border="0" alt=""></td>


<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" valign="top" bgcolor="#3333cc"><img src="navlist.gif" alt=""></td>
<td bgcolor="#3333cc" width="104" class="nav"><a href=http://slashdot.org/bsd/01/06/01/1135203.shtml class=yel>Slashdot: OpenBSD 2.9 Released</td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
</tr>
<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
<td colspan="4" bgcolor="#3333cc" width="128"><img src="t.gif" alt="" width="2" height="6" border="0" alt=""></td>


<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td width="8" valign="top" bgcolor="#3333cc"><img src="navlist.gif" alt=""></td>
<td bgcolor="#3333cc" width="104" class="nav"><a href=http://investor.cnet.com/investor/news/newsitem/0-9900-1028-6137962-0.html?tag=ats class=yel>CNET: Central Command Releases Its Dirty Dozen -- Top 12 -- Viruses For May 2001 </td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
</tr>
<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
<td colspan="4" bgcolor="#3333cc" width="128"><img src="t.gif" alt="" width="2" height="6" border="0" alt=""></td>



<tr>
<td width="2" bgcolor="#000000"><img src="t.gif" alt="" width=2 height=20 border=0></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height=2 border=0></td>
<td bgcolor="#3333cc" width="104" colspan="2" class="nav" valign="top"><a href="/topnews/" class=white>More News</a></td>
<td width="8" bgcolor="#3333cc"><img src="t.gif" alt="" width=2 height="2" border="0"></td>
</tr>
		
		<tr>
		<td colspan=5 height=2 bgcolor=#000000 text=#FFFFFF><img src=t.gif alt="" width=2 height=2 border=0></td>
		</tr>
		
		</table>

<br><table cellpadding=2 cellspacing=0 border=0>
  <tr>
	<td valign="bottom"><a href="/feedback.html"><img src="feedback.gif" border=0></a> 
	</td>
	<td width="1">&nbsp;
	<td valign="top"><p><a href="/feedback.html" class="blu">Send Feedback</a></p>
  </tr>
</table>


	<div class=search>
	&nbsp;

<!--	<p class=news><a href="" class=blu>email this article<br>to a friend</a></p> -->
	<table cellpadding=2 cellspacing=0 border=0>
      <tr>
        <td valign="bottom"> <a href="/closet/closet20001122.printerfriendly.html" class=blu><img src="printerfriendly.gif" border=0></a> 
        </td>
        <td width="1">&nbsp;
        <td valign="top"><p><a href="/closet/closet20001122.printerfriendly.html" class=blu>Print 
            this Article</a></p>
      </tr>
    </table>

	</div>


	</td>
	</tr>
	
	</table>

<!-- *** bottom area *** -->
</td>
</tr>

<tr>
<td bgcolor=#ffcc00 height=2><img src=t.gif alt="" width=2 height=2 border=0></td>
</tr>
</table>
</td></tr>
<tr><td><table width=100% cellpadding=0 cellspacing=0 border=0>
<tr>
<td width=10 height=40><img src=t.gif alt="" width=10 height=40 border=0 bgcolor=#000000 text=#FFFFFF></td>
<td width=126 bgcolor=#000000 text=#FFFFFF><img src=t.gif alt="" width=126 height=40 border=0></td>
<td width=100% bgcolor=#000000 text=#FFFFFF valign=middle height=40>


          <div class=footer> <a href="/" class=yel>Home</a> | <a href="http://search.securityportal.com" class=yel>Search</a> 
            | <a href="/feedback.html" class=yel>Feedback</a> | <a href="/about/privacy.html" class=yel>Privacy 
            Policy</a> | <a href="/about/sponsorship.html" class=yel>Advertise</a> 
            | <a href="/about/" class=yel>About SecurityPortal</a> </div>

<div class="copy">&copy; Copyright 1999-2001 AtomicTangerine, Inc. All rights reserved.</div>
</td>

</tr>
</table>
</td>
</tr>
</table>

</body>
</html>
